% Comparison DCT-based and DFT-based convolutions
% Copyright L. Yaroslavsky (yaro@eng.tau.ac.il)
% 
close all
kern=zeros(1,128);kern(65-8:65+8)=1;
sp_kern1=fft(kern);
sp_kern2=fft(fftshift(kern(33:96)));
for k=1:64,
    kk=k+32; if kk>64,kk=kk-64;end 
    s=zeros(1,64);s(kk)=1;
    sp_s=fft(s);
    ss=[s,fliplr(s)];
    sp_ss=fft(ss);
    convol_dct=real(ifft(sp_ss.*sp_kern1));
    convol_dft=real(ifft(sp_s.*sp_kern2));
    subplot(2,1,1);
    stem(s,'.','LineWidth',2);  
    grid on;
    axis([1 64 0 1.2]);
    title('Input','FontWeight','Bold')
    set(gca,'FontSize',10);set(gca,'FontName','Helvetica');set(gca,'FontWeight','Bold');
    subplot(2,1,2);
    plot(1:64,convol_dct(65:128),'r.-',1:64,convol_dft,'bo-','LineWidth',2);
    grid on
    axis([1 64 0 2.2]);
    drawnow;
    legend('DCTconv','DFTconv',0);
    title('Convolution with a rectangular kernel','FontWeight','Bold')
    set(gca,'FontSize',10);set(gca,'FontName','Helvetica');set(gca,'FontWeight','Bold');
%     if k==1, pause,end
%     if k==30, pause,end
%     if k==34, pause,end
    pause(0.25)
end